#!/system/bin/sh
###> Initializing
AD2SDX_VERSION="1.00-RC01"
sync;

######################################################
#            AD2SDX DALVIK WAITER SCRIPT             #
######################################################
  echo "AD2SDX Dalvik Waiter Script Version $AD2SDX_VERSION";
  echo "       by AMARULLZ - xda-developers";
  echo "";
  echo "Initializing First Boot...";
  echo "Wait System to Finish the Boot...";

###> Wait For Boot Finished & Dalvik-Cache Initialized
  IS_BOOT_FINISHED="no";
  while [ $IS_BOOT_FINISHED != "yes" ]
  do
    ps | grep com.android.systemui  > /dev/null;
    if [ $? = 0 ]; then
        IS_BOOT_FINISHED="yes";
    else
        ###> Even it settled, we wait for 5 seconds ;)
        sleep 5;
    fi
  done;
  sync;

###> Now Do The Structurizing Actions
  echo "";
  echo "Initializing 3rd Party Dalvik Cache Directory...";
  busybox mkdir /data/dalvik-temp
  busybox chmod 777 /data/dalvik-temp

###> Copy Application Dalvik to dalvik-temp
  cd /sd-ext/dalvik-cache;
  echo "Dalvik On SD-EXT:";
  for i in `ls data*`;
  do
    busybox cp -a /sd-ext/dalvik-cache/$i /data/dalvik-temp/$i;
    echo "  $i";
  done;
  echo "Dalvik On Internal Storage:";
  for i in `ls system*`;
  do
    busybox ln -s /sd-ext/dalvik-cache/$i /data/dalvik-temp/$i;
    echo "  $i";
  done;
  echo "";
  echo "Configuring...";
  busybox mv /data/dalvik-cache /data/dalvik-delete;
  busybox mv /data/dalvik-temp /data/dalvik-cache;
  busybox rm -R /data/dalvik-delete;
  busybox rm data*;
  cd /;
  echo "Completed...";
  sync;
